Bug 483391 - [te_IN] New Telugu codepoints/glyphs in Unicode 5.1
[te_IN] New Telugu codepoints/glyphs in Unicode 5.1
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: lohit-fonts (Show other bugs)
10
All Linux
low Severity medium
: ---
: ---
Assigned To: Pravin Satpute
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-01-31 09:08 EST by Padmanabhan V. K.
Modified: 2009-08-11 00:57 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-08-11 00:57:57 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
untested patch for Lohit-Telugu.sfd (96.19 KB, patch)
2009-01-31 10:17 EST, Padmanabhan V. K.
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
GNOME Desktop 569244 None None None Never

  None (edit)
Description Padmanabhan V. K. 2009-01-31 09:08:27 EST
+++ This bug was initially created as a clone of Bug #202400 +++

Description of problem:
following glyphs are not present in Lohit Telugu

U+0C3D ఽ TELUGU SIGN AVAGRAHA
U+0C58 ౘ TELUGU LETTER TSA
U+0C59 ౙ TELUGU LETTER DZA
U+0C62 ౢ TELUGU VOWEL SIGN VOCALIC L
U+0C63 ౣ TELUGU VOWEL SIGN VOCALIC LL
U+0C78 ౸ TELUGU FRACTION DIGIT ZERO FOR ODD POWERS OF FOUR
U+0C79 ౹ TELUGU FRACTION DIGIT ONE FOR ODD POWERS OF FOUR
U+0C7A ౺ TELUGU FRACTION DIGIT TWO FOR ODD POWERS OF FOUR
U+0C7B ౻ TELUGU FRACTION DIGIT THREE FOR ODD POWERS OF FOUR
U+0C7C ౼ TELUGU FRACTION DIGIT ONE FOR EVEN POWERS OF FOUR
U+0C7D ౽ TELUGU FRACTION DIGIT TWO FOR EVEN POWERS OF FOUR
U+0C7E ౾ TELUGU FRACTION DIGIT THREE FOR EVEN POWERS OF FOUR
U+0C7F ౿ TELUGU SIGN TUUMU

Version-Release number of selected component (if applicable):
lohit-fonts-2.3.1-1.fc10

Additional info:
1) http://www.unicode.org/charts/PDF/Unicode-5.1/U51-0C00.pdf (chart showing new characters)
2) http://std.dkuug.dk/jtc1/sc2/wg2/docs/n3116.pdf (proposal for adding these characters among others, that details the use of these characters)
Comment 1 Padmanabhan V. K. 2009-01-31 10:17:23 EST
Created attachment 330523 [details]
untested patch for Lohit-Telugu.sfd

For reference, the Pothana2000 font from http://www.kavya-nandanam.com/dload.htm already has all these characters.

I am put up with an old Mandriva distro with pango-1.10.0-3mdk and
fontforge-1.0-0.20050809.1mdk. I used the Lohit Telugu font extracted from
lohit-fonts-2.3.1-1.fc10.src.rpm. I used the above fontforge (which cannot create or open the latest .sfd format), added some glyphs and created an old-format .sfd.

Then I manually copied the changes to http://fedorahosted.org/lohit/browser/trunk/Lohit-Telugu.sfd and created the attached patch, which could hence be a bit unreliable.

The changes made are:
1. Extra ligature rules in U0C1A_U0C4D.blwf and U0C1C_U0C4D.blwf for these glyphs to double-up as the below-base forms of U0C58 and U0C59.
2. New glyphs U0C58, U0C58_U0C3E.abvs, U0C58_U0C3F.abvs, U0C58_U0C40.abvs, U0C58_U0C46.abvs, U0C58_U0C47.abvs, U0C58_U0C4A.abvs, U0C58_U0C4B.abvs, U0C58_U0C4C.abvs, U0C58_U0C4D.haln created from the corresponding U0C1A_* glyphs by pasting the shape of U0C24_U0C4D.blwf above them and trimming its length to match the extremities of the base character (ca/ja) in the glyphs. Note that the .sfd produced by my fontforge rounds the x/y coordinates of points to the nearest integer or sometimes multiple of 0.5. Hence the shape of U0C24_U0C4D.blwf added above the glyphs only has integral coordinates in my patch.
3. New glyphs U0C59, U0C59_U0C3E.abvs, U0C59_U0C3F.abvs, U0C59_U0C40.abvs, U0C59_U0C46.abvs, U0C59_U0C47.abvs, U0C59_U0C4A.abvs, U0C59_U0C4B.abvs, U0C59_U0C4C.abvs, U0C59_U0C4D.haln, U0C59_U0C41.psts, U0C59_U0C42.psts created from the corresponding U0C1C_* glyphs by pasting the shape of U0C24_U0C4D.blwf above them and trimming its length to match the extremities of the base character (ca/ja) in the glyphs. Note that the .sfd produced by my fontforge rounds the x/y coordinates of points to the nearest integer or sometimes multiple of 0.5. Hence the shape of U0C24_U0C4D.blwf added above the glyphs only has integral coordinates in my patch.
4. "GlyphClass:" lines of the new glyphs are fixed to reflect if the glyph is a "ligature" (3) per my patch (attachment 330034 [details]) to bug 476427. "MultipleSubs2:" lines are added to the new glyphs U0C58 and U0C59 based on the corresponding lines in U0C1A and U0C1C although they don't make sense to me.
5. New glyphs U0C62, U0C63 created by using the U0C32_U0C4D.blwf shape in the background, pasting the shapes of U0C0C and U0C61 and moving & resizing them so that the top-left portion of them almost coincides with the background, and removing the background. Note that the .sfd produced by my fontforge rounds the x/y coordinates of points to the nearest integer or sometimes multiple of 0.5. Hence the glyphs only have integral coordinates in my patch.
6. "GlyphClass:" lines of these 2 glyphs are set to reflect they are "mark"s (4) per my patch (attachment 330034 [details]) to bug 476427. The "Width:" lines of these 2 glyphs are set based on their right extremity, like some of the non-zero width below-base forms.

The avagraha & fractional digits are unrelated to existing shapes, so with my zero knowledge of designing fonts I don't know how to create them with a look & feel consistent with other glyphs.

Note that "VWidth:" lines have not been changed from 819 although some of the new glyphs are much taller than that.
Comment 3 sandeep shedmake 2009-07-24 10:26:00 EDT
From Comment #1,

pothana2000-fonts is now available in Fedora-10.
Comment 4 Pravin Satpute 2009-08-04 02:52:52 EDT
done the required changes 
latest build available in rawhide
lohit-fonts-2.4.0-1

one can install rpm from
http://koji.fedoraproject.org/koji/taskinfo?taskID=1578280 for testing

Note You need to log in before you can comment on or make changes to this bug.